diff --git a/src/backend/access/transam/slru.c b/src/backend/access/transam/slru.c
index 77edc51e1c..3e58314df3 100644
--- a/src/backend/access/transam/slru.c
+++ b/src/backend/access/transam/slru.c
@@ -57,6 +57,7 @@
 #include "pgstat.h"
 #include "storage/fd.h"
 #include "storage/shmem.h"
+#include "utils/hsearch.h"
 #include "miscadmin.h"
 
 
@@ -81,6 +82,13 @@ typedef struct SlruFlushData
 
 typedef struct SlruFlushData *SlruFlush;
 
+/* An entry of page-to-slot hash map */
+typedef struct PageSlotEntry
+{
+	int page;
+	int slot;
+} PageSlotEntry;
+
 /*
  * Macro to mark a buffer slot "most recently used".  Note multiple evaluation
  * of arguments!
@@ -166,11 +174,24 @@ SimpleLruInit(SlruCtl ctl, const char *name, int nslots, int nlsns,
 			  LWLock *ctllock, const char *subdir, int tranche_id)
 {
 	SlruShared	shared;
+	char *hashName;
+	HTAB *htab;
 	bool		found;
+	HASHCTL info;
 
 	shared = (SlruShared) ShmemInitStruct(name,
 										  SimpleLruShmemSize(nslots, nlsns),
 										  &found);
+	hashName = psprintf("%s_hash", name);
+
+	MemSet(&info, 0, sizeof(info));
+	info.keysize = sizeof(((PageSlotEntry*)0)->page);
+	info.entrysize = sizeof(PageSlotEntry);
+
+	htab = ShmemInitHash(hashName, nslots, nslots, &info,
+						 HASH_ELEM | HASH_BLOBS | HASH_FIXED_SIZE);
+
+	pfree(hashName);
 
 	if (!IsUnderPostmaster)
 	{
@@ -247,6 +268,7 @@ SimpleLruInit(SlruCtl ctl, const char *name, int nslots, int nlsns,
 	 * assume caller set PagePrecedes.
 	 */
 	ctl->shared = shared;
+	ctl->pageToSlot = htab;
 	ctl->do_fsync = true;		/* default behavior */
 	StrNCpy(ctl->Dir, subdir, sizeof(ctl->Dir));
 }
@@ -264,6 +286,7 @@ SimpleLruZeroPage(SlruCtl ctl, int pageno)
 {
 	SlruShared	shared = ctl->shared;
 	int			slotno;
+	PageSlotEntry *entry = NULL;
 
 	/* Find a suitable buffer slot for the page */
 	slotno = SlruSelectLRUPage(ctl, pageno);
@@ -273,7 +296,16 @@ SimpleLruZeroPage(SlruCtl ctl, int pageno)
 		   shared->page_number[slotno] == pageno);
 
 	/* Mark the slot as containing this page */
+	if (shared->page_status[slotno] == SLRU_PAGE_VALID)
+	{
+		int oldpageno = shared->page_number[slotno];
+		entry = hash_search(ctl->pageToSlot, &oldpageno, HASH_REMOVE, NULL);
+		Assert(entry != NULL);
+	}
+
 	shared->page_number[slotno] = pageno;
+	entry = hash_search(ctl->pageToSlot, &pageno, HASH_ENTER, NULL);
+	entry->slot = slotno;
 	shared->page_status[slotno] = SLRU_PAGE_VALID;
 	shared->page_dirty[slotno] = true;
 	SlruRecentlyUsed(shared, slotno);
@@ -343,8 +375,14 @@ SimpleLruWaitIO(SlruCtl ctl, int slotno)
 		{
 			/* indeed, the I/O must have failed */
 			if (shared->page_status[slotno] == SLRU_PAGE_READ_IN_PROGRESS)
+			{
+				int oldpageno = shared->page_number[slotno];
+				PageSlotEntry *entry = hash_search(ctl->pageToSlot, &oldpageno, HASH_REMOVE, NULL);
+
+				Assert(entry != NULL);
 				shared->page_status[slotno] = SLRU_PAGE_EMPTY;
-			else				/* write_in_progress */
+			}
+			else	/* write_in_progress */
 			{
 				shared->page_status[slotno] = SLRU_PAGE_VALID;
 				shared->page_dirty[slotno] = true;
@@ -382,6 +420,7 @@ SimpleLruReadPage(SlruCtl ctl, int pageno, bool write_ok,
 	{
 		int			slotno;
 		bool		ok;
+		PageSlotEntry *entry;
 
 		/* See if page already is in memory; if not, pick victim slot */
 		slotno = SlruSelectLRUPage(ctl, pageno);
@@ -413,7 +452,16 @@ SimpleLruReadPage(SlruCtl ctl, int pageno, bool write_ok,
 				!shared->page_dirty[slotno]));
 
 		/* Mark the slot read-busy */
+		if (shared->page_status[slotno] == SLRU_PAGE_VALID)
+		{
+			int oldpageno = shared->page_number[slotno];
+			PageSlotEntry *entry = hash_search(ctl->pageToSlot, &oldpageno, HASH_REMOVE, NULL);
+			Assert(entry != NULL);
+		}
+
 		shared->page_number[slotno] = pageno;
+		entry = hash_search(ctl->pageToSlot, &pageno, HASH_ENTER, NULL);
+		entry->slot = slotno;
 		shared->page_status[slotno] = SLRU_PAGE_READ_IN_PROGRESS;
 		shared->page_dirty[slotno] = false;
 
@@ -436,7 +484,16 @@ SimpleLruReadPage(SlruCtl ctl, int pageno, bool write_ok,
 			   shared->page_status[slotno] == SLRU_PAGE_READ_IN_PROGRESS &&
 			   !shared->page_dirty[slotno]);
 
-		shared->page_status[slotno] = ok ? SLRU_PAGE_VALID : SLRU_PAGE_EMPTY;
+		if (ok)
+		{
+			shared->page_status[slotno] = SLRU_PAGE_VALID;
+		}
+		else
+		{
+			PageSlotEntry *entry = hash_search(ctl->pageToSlot, &pageno, HASH_REMOVE, NULL);
+			Assert(entry != NULL);
+			shared->page_status[slotno] = SLRU_PAGE_EMPTY;
+		}
 
 		LWLockRelease(&shared->buffer_locks[slotno].lock);
 
@@ -467,19 +524,22 @@ int
 SimpleLruReadPage_ReadOnly(SlruCtl ctl, int pageno, TransactionId xid)
 {
 	SlruShared	shared = ctl->shared;
-	int			slotno;
+	PageSlotEntry *entry = NULL;
+	int slotno;
 
 	/* Try to find the page while holding only shared lock */
 	LWLockAcquire(shared->ControlLock, LW_SHARED);
 
 	/* See if page is already in a buffer */
-	for (slotno = 0; slotno < shared->num_slots; slotno++)
+	entry = hash_search(ctl->pageToSlot, &pageno, HASH_FIND, NULL);
+	if (entry != NULL)
 	{
-		if (shared->page_number[slotno] == pageno &&
-			shared->page_status[slotno] != SLRU_PAGE_EMPTY &&
-			shared->page_status[slotno] != SLRU_PAGE_READ_IN_PROGRESS)
+		slotno = entry->slot;
+		Assert(shared->page_status[slotno] != SLRU_PAGE_EMPTY);
+		if (shared->page_status[slotno] != SLRU_PAGE_EMPTY
+			&& shared->page_status[slotno] != SLRU_PAGE_READ_IN_PROGRESS)
 		{
-			/* See comments for SlruRecentlyUsed macro */
+			Assert(shared->page_number[slotno] == pageno);
 			SlruRecentlyUsed(shared, slotno);
 			return slotno;
 		}
@@ -493,6 +553,44 @@ SimpleLruReadPage_ReadOnly(SlruCtl ctl, int pageno, TransactionId xid)
 }
 
 /*
+ * Same as SimpleLruReadPage_ReadOnly, but the shared lock must be held by the caller
+ * and will be held at exit.
+ */
+int
+SimpleLruReadPage_ReadOnly_Locked(SlruCtl ctl, int pageno, TransactionId xid)
+{
+	SlruShared	shared = ctl->shared;
+	int slotno;
+	PageSlotEntry *entry;
+
+	Assert(LWLockHeldByMe(shared->ControlLock));
+
+	for (;;)
+	{
+		/* See if page is already in a buffer */
+		entry = hash_search(ctl->pageToSlot, &pageno, HASH_FIND, NULL);
+		if (entry != NULL)
+		{
+			slotno = entry->slot;
+			if (shared->page_status[slotno] != SLRU_PAGE_EMPTY
+				&& shared->page_status[slotno] != SLRU_PAGE_READ_IN_PROGRESS)
+			{
+				Assert(shared->page_number[slotno] == pageno);
+				SlruRecentlyUsed(shared, slotno);
+				return slotno;
+			}
+		}
+
+		/* No luck, so switch to normal exclusive lock and do regular read */
+		LWLockRelease(shared->ControlLock);
+		LWLockAcquire(shared->ControlLock, LW_EXCLUSIVE);
+		SimpleLruReadPage(ctl, pageno, true, xid);
+		LWLockRelease(shared->ControlLock);
+		LWLockAcquire(shared->ControlLock, LW_SHARED);
+	}
+}
+
+/*
  * Write a page from a shared buffer, if necessary.
  * Does nothing if the specified slot is not dirty.
  *
@@ -976,9 +1074,9 @@ SlruSelectLRUPage(SlruCtl ctl, int pageno)
 		int			bestvalidslot = 0;	/* keep compiler quiet */
 		int			best_valid_delta = -1;
 		int			best_valid_page_number = 0; /* keep compiler quiet */
-		int			bestinvalidslot = 0;	/* keep compiler quiet */
+		int			bestinvalidslot = 0;		/* keep compiler quiet */
 		int			best_invalid_delta = -1;
-		int			best_invalid_page_number = 0;	/* keep compiler quiet */
+		int			best_invalid_page_number = 0;		/* keep compiler quiet */
 
 		/* See if page already has a buffer assigned */
 		for (slotno = 0; slotno < shared->num_slots; slotno++)
@@ -1214,6 +1312,9 @@ restart:;
 		if (shared->page_status[slotno] == SLRU_PAGE_VALID &&
 			!shared->page_dirty[slotno])
 		{
+			int oldpageno = shared->page_number[slotno];
+			PageSlotEntry *entry = hash_search(ctl->pageToSlot, &oldpageno, HASH_REMOVE, NULL);
+			Assert(entry != NULL);
 			shared->page_status[slotno] = SLRU_PAGE_EMPTY;
 			continue;
 		}
@@ -1285,6 +1386,9 @@ restart:
 		if (shared->page_status[slotno] == SLRU_PAGE_VALID &&
 			!shared->page_dirty[slotno])
 		{
+			int oldpageno = shared->page_number[slotno];
+			PageSlotEntry *entry = hash_search(ctl->pageToSlot, &oldpageno, HASH_REMOVE, NULL);
+			Assert(entry != NULL);
 			shared->page_status[slotno] = SLRU_PAGE_EMPTY;
 			continue;
 		}
diff --git a/src/backend/access/transam/transam.c b/src/backend/access/transam/transam.c
index 968b232364..e2dd957693 100644
--- a/src/backend/access/transam/transam.c
+++ b/src/backend/access/transam/transam.c
@@ -3,6 +3,15 @@
  * transam.c
  *	  postgres transaction (commit) log interface routines
  *
+ * This module contains high level functions for managing the status
+ * of transactions. It sits on top of two lower level structures: the
+ * CLOG, and the CSNLOG. The CLOG is a permanent on-disk structure that
+ * tracks the committed/aborted status for each transaction ID. The CSNLOG
+ * tracks *when* each transaction ID committed (or aborted). The CSNLOG
+ * is used when checking the status of recent transactions that might still
+ * be in-progress, and it is reset at server startup. The CLOG is used for
+ * older transactions that are known to have completed (or crashed).
+ *
  * Portions Copyright (c) 1996-2017, PostgreSQL Global Development Group
  * Portions Copyright (c) 1994, Regents of the University of California
  *
@@ -10,56 +19,49 @@
  * IDENTIFICATION
  *	  src/backend/access/transam/transam.c
  *
- * NOTES
- *	  This file contains the high level access-method interface to the
- *	  transaction system.
- *
  *-------------------------------------------------------------------------
  */
 
 #include "postgres.h"
 
 #include "access/clog.h"
+#include "access/csnlog.h"
+#include "access/mvccvars.h"
 #include "access/subtrans.h"
 #include "access/transam.h"
+#include "storage/lmgr.h"
 #include "utils/snapmgr.h"
 
 /*
- * Single-item cache for results of TransactionLogFetch.  It's worth having
+ * Single-item cache for results of TransactionIdGetCommitSeqNo.  It's worth
+ * having
  * such a cache because we frequently find ourselves repeatedly checking the
  * same XID, for example when scanning a table just after a bulk insert,
  * update, or delete.
  */
 static TransactionId cachedFetchXid = InvalidTransactionId;
-static XidStatus cachedFetchXidStatus;
-static XLogRecPtr cachedCommitLSN;
+static CommitSeqNo cachedCSN;
 
-/* Local functions */
-static XidStatus TransactionLogFetch(TransactionId transactionId);
-
-
-/* ----------------------------------------------------------------
- *		Postgres log access method interface
- *
- *		TransactionLogFetch
- * ----------------------------------------------------------------
+/*
+ * Also have a (separate) cache for CLogGetCommitLSN()
  */
+static TransactionId cachedLSNFetchXid = InvalidTransactionId;
+static XLogRecPtr cachedCommitLSN;
 
 /*
- * TransactionLogFetch --- fetch commit status of specified transaction id
+ * TransactionIdGetCommitSeqNo --- fetch CSN of specified transaction id
  */
-static XidStatus
-TransactionLogFetch(TransactionId transactionId)
+CommitSeqNo
+TransactionIdGetCommitSeqNo(TransactionId transactionId)
 {
-	XidStatus	xidstatus;
-	XLogRecPtr	xidlsn;
+	CommitSeqNo	csn;
 
 	/*
 	 * Before going to the commit log manager, check our single item cache to
 	 * see if we didn't just check the transaction status a moment ago.
 	 */
 	if (TransactionIdEquals(transactionId, cachedFetchXid))
-		return cachedFetchXidStatus;
+		return cachedCSN;
 
 	/*
 	 * Also, check to see if the transaction ID is a permanent one.
@@ -67,53 +69,63 @@ TransactionLogFetch(TransactionId transactionId)
 	if (!TransactionIdIsNormal(transactionId))
 	{
 		if (TransactionIdEquals(transactionId, BootstrapTransactionId))
-			return TRANSACTION_STATUS_COMMITTED;
+			return COMMITSEQNO_FROZEN;
 		if (TransactionIdEquals(transactionId, FrozenTransactionId))
-			return TRANSACTION_STATUS_COMMITTED;
-		return TRANSACTION_STATUS_ABORTED;
+			return COMMITSEQNO_FROZEN;
+		return COMMITSEQNO_ABORTED;
 	}
 
 	/*
-	 * Get the transaction status.
+	 * If the XID is older than TransactionXmin, check the clog. Otherwise
+	 * check the csnlog.
 	 */
-	xidstatus = TransactionIdGetStatus(transactionId, &xidlsn);
+	Assert(TransactionIdIsValid(TransactionXmin));
+	if (TransactionIdPrecedes(transactionId, TransactionXmin))
+	{
+		XLogRecPtr lsn;
+
+		if (CLogGetStatus(transactionId, &lsn) == CLOG_XID_STATUS_COMMITTED)
+			csn = COMMITSEQNO_FROZEN;
+		else
+			csn = COMMITSEQNO_ABORTED;
+	}
+	else
+	{
+		csn = CSNLogGetCommitSeqNo(transactionId);
+
+		if (csn == COMMITSEQNO_COMMITTING)
+		{
+			/*
+			 * If the transaction is committing at this very instant, and
+			 * hasn't set its CSN yet, wait for it to finish doing so.
+			 *
+			 * XXX: Alternatively, we could wait on the heavy-weight lock on
+			 * the XID. that'd make TransactionIdCommitTree() slightly
+			 * cheaper, as it wouldn't need to acquire CommitSeqNoLock (even
+			 * in shared mode).
+			 */
+			LWLockAcquire(CommitSeqNoLock, LW_EXCLUSIVE);
+			LWLockRelease(CommitSeqNoLock);
+
+			csn = CSNLogGetCommitSeqNo(transactionId);
+			Assert(csn != COMMITSEQNO_COMMITTING);
+		}
+	}
 
 	/*
-	 * Cache it, but DO NOT cache status for unfinished or sub-committed
-	 * transactions!  We only cache status that is guaranteed not to change.
+	 * Cache it, but DO NOT cache status for unfinished transactions!
+	 * We only cache status that is guaranteed not to change.
 	 */
-	if (xidstatus != TRANSACTION_STATUS_IN_PROGRESS &&
-		xidstatus != TRANSACTION_STATUS_SUB_COMMITTED)
+	if (COMMITSEQNO_IS_COMMITTED(csn) ||
+		COMMITSEQNO_IS_ABORTED(csn))
 	{
 		cachedFetchXid = transactionId;
-		cachedFetchXidStatus = xidstatus;
-		cachedCommitLSN = xidlsn;
+		cachedCSN = csn;
 	}
 
-	return xidstatus;
+	return csn;
 }
 
-/* ----------------------------------------------------------------
- *						Interface functions
- *
- *		TransactionIdDidCommit
- *		TransactionIdDidAbort
- *		========
- *		   these functions test the transaction status of
- *		   a specified transaction id.
- *
- *		TransactionIdCommitTree
- *		TransactionIdAsyncCommitTree
- *		TransactionIdAbortTree
- *		========
- *		   these functions set the transaction status of the specified
- *		   transaction tree.
- *
- * See also TransactionIdIsInProgress, which once was in this module
- * but now lives in procarray.c.
- * ----------------------------------------------------------------
- */
-
 /*
  * TransactionIdDidCommit
  *		True iff transaction associated with the identifier did commit.
@@ -124,50 +136,14 @@ TransactionLogFetch(TransactionId transactionId)
 bool							/* true if given transaction committed */
 TransactionIdDidCommit(TransactionId transactionId)
 {
-	XidStatus	xidstatus;
+	CommitSeqNo csn;
 
-	xidstatus = TransactionLogFetch(transactionId);
+	csn = TransactionIdGetCommitSeqNo(transactionId);
 
-	/*
-	 * If it's marked committed, it's committed.
-	 */
-	if (xidstatus == TRANSACTION_STATUS_COMMITTED)
+	if (COMMITSEQNO_IS_COMMITTED(csn))
 		return true;
-
-	/*
-	 * If it's marked subcommitted, we have to check the parent recursively.
-	 * However, if it's older than TransactionXmin, we can't look at
-	 * pg_subtrans; instead assume that the parent crashed without cleaning up
-	 * its children.
-	 *
-	 * Originally we Assert'ed that the result of SubTransGetParent was not
-	 * zero. However with the introduction of prepared transactions, there can
-	 * be a window just after database startup where we do not have complete
-	 * knowledge in pg_subtrans of the transactions after TransactionXmin.
-	 * StartupSUBTRANS() has ensured that any missing information will be
-	 * zeroed.  Since this case should not happen under normal conditions, it
-	 * seems reasonable to emit a WARNING for it.
-	 */
-	if (xidstatus == TRANSACTION_STATUS_SUB_COMMITTED)
-	{
-		TransactionId parentXid;
-
-		if (TransactionIdPrecedes(transactionId, TransactionXmin))
-			return false;
-		parentXid = SubTransGetParent(transactionId);
-		if (!TransactionIdIsValid(parentXid))
-		{
-			elog(WARNING, "no pg_subtrans entry for subcommitted XID %u",
-				 transactionId);
-			return false;
-		}
-		return TransactionIdDidCommit(parentXid);
-	}
-
-	/*
-	 * It's not committed.
-	 */
-	return false;
+	else
+		return false;
 }
 
 /*
@@ -180,70 +156,35 @@ TransactionIdDidCommit(TransactionId transactionId)
 bool							/* true if given transaction aborted */
 TransactionIdDidAbort(TransactionId transactionId)
 {
-	XidStatus	xidstatus;
+	CommitSeqNo csn;
 
-	xidstatus = TransactionLogFetch(transactionId);
+	csn = TransactionIdGetCommitSeqNo(transactionId);
 
-	/*
-	 * If it's marked aborted, it's aborted.
-	 */
-	if (xidstatus == TRANSACTION_STATUS_ABORTED)
+	if (COMMITSEQNO_IS_ABORTED(csn))
 		return true;
-
-	/*
-	 * If it's marked subcommitted, we have to check the parent recursively.
-	 * However, if it's older than TransactionXmin, we can't look at
-	 * pg_subtrans; instead assume that the parent crashed without cleaning up
-	 * its children.
-	 */
-	if (xidstatus == TRANSACTION_STATUS_SUB_COMMITTED)
-	{
-		TransactionId parentXid;
-
-		if (TransactionIdPrecedes(transactionId, TransactionXmin))
-			return true;
-		parentXid = SubTransGetParent(transactionId);
-		if (!TransactionIdIsValid(parentXid))
-		{
-			/* see notes in TransactionIdDidCommit */
-			elog(WARNING, "no pg_subtrans entry for subcommitted XID %u",
-				 transactionId);
-			return true;
-		}
-		return TransactionIdDidAbort(parentXid);
-	}
-
-	/*
-	 * It's not aborted.
-	 */
-	return false;
+	else
+		return false;
 }
 
 /*
- * TransactionIdIsKnownCompleted
- *		True iff transaction associated with the identifier is currently
- *		known to have either committed or aborted.
+ * Returns the status of the tranaction.
  *
- * This does NOT look into pg_xact but merely probes our local cache
- * (and so it's not named TransactionIdDidComplete, which would be the
- * appropriate name for a function that worked that way).  The intended
- * use is just to short-circuit TransactionIdIsInProgress calls when doing
- * repeated tqual.c checks for the same XID.  If this isn't extremely fast
- * then it will be counterproductive.
- *
- * Note:
- *		Assumes transaction identifier is valid.
+ * Note that this treats a a crashed transaction as still in-progress,
+ * until it falls off the xmin horizon.
  */
-bool
-TransactionIdIsKnownCompleted(TransactionId transactionId)
+TransactionIdStatus
+TransactionIdGetStatus(TransactionId xid)
 {
-	if (TransactionIdEquals(transactionId, cachedFetchXid))
-	{
-		/* If it's in the cache at all, it must be completed. */
-		return true;
-	}
+	CommitSeqNo csn;
+
+	csn = TransactionIdGetCommitSeqNo(xid);
 
-	return false;
+	if (COMMITSEQNO_IS_COMMITTED(csn))
+		return XID_COMMITTED;
+	else if (COMMITSEQNO_IS_ABORTED(csn))
+		return XID_ABORTED;
+	else
+		return XID_INPROGRESS;
 }
 
 /*
@@ -252,28 +193,82 @@ TransactionIdIsKnownCompleted(TransactionId transactionId)
  *
  * "xid" is a toplevel transaction commit, and the xids array contains its
  * committed subtransactions.
- *
- * This commit operation is not guaranteed to be atomic, but if not, subxids
- * are correctly marked subcommit first.
  */
 void
 TransactionIdCommitTree(TransactionId xid, int nxids, TransactionId *xids)
 {
-	TransactionIdSetTreeStatus(xid, nxids, xids,
-							   TRANSACTION_STATUS_COMMITTED,
-							   InvalidXLogRecPtr);
+	TransactionIdAsyncCommitTree(xid, nxids, xids, InvalidXLogRecPtr);
 }
 
 /*
  * TransactionIdAsyncCommitTree
- *		Same as above, but for async commits.  The commit record LSN is needed.
+ *		Same as above, but for async commits.
+ *
+ * "xid" is a toplevel transaction commit, and the xids array contains its
+ * committed subtransactions.
  */
 void
 TransactionIdAsyncCommitTree(TransactionId xid, int nxids, TransactionId *xids,
 							 XLogRecPtr lsn)
 {
-	TransactionIdSetTreeStatus(xid, nxids, xids,
-							   TRANSACTION_STATUS_COMMITTED, lsn);
+	CommitSeqNo csn;
+	TransactionId latestXid;
+	TransactionId currentLatestCompletedXid;
+
+	latestXid = TransactionIdLatest(xid, nxids, xids);
+	/*
+	 * First update the clog, then CSN log.
+	 * oldestActiveXid advances based on CSN log content (see
+	 * AdvanceOldestActiveXid), and it should not become greater than
+	 * our xid before we set the clog status.
+	 * Otherwise other transactions could see us as aborted for some time
+	 * after we have written to CSN log, and somebody advanced the oldest
+	 * active xid past our xid, but before we write to clog.
+	 */
+	CLogSetTreeStatus(xid, nxids, xids,
+					  CLOG_XID_STATUS_COMMITTED,
+					  lsn);
+
+	/*
+	 * Grab the CommitSeqNoLock, in shared mode. This is only used to
+	 * provide a way for a concurrent transaction to wait for us to
+	 * complete (see TransactionIdGetCommitSeqNo()).
+	 *
+	 * XXX: We could reduce the time the lock is held, by only setting
+	 * the CSN on the top-XID while holding the lock, and updating the
+	 * sub-XIDs later. But it doesn't matter much, because we're only
+	 * holding it in shared mode, and it's rare for it to be acquired
+	 * in exclusive mode.
+	 */
+	LWLockAcquire(CommitSeqNoLock, LW_SHARED);
+
+	/*
+	 * First update latestCompletedXid to cover this xid. We do this before
+	 * assigning a CSN, so that if someone acquires a new snapshot at the same
+	 * time, the xmax it computes is sure to cover our XID.
+	 */
+	currentLatestCompletedXid = pg_atomic_read_u32(&ShmemVariableCache->latestCompletedXid);
+	while (TransactionIdFollows(latestXid, currentLatestCompletedXid))
+	{
+		if (pg_atomic_compare_exchange_u32(&ShmemVariableCache->latestCompletedXid,
+										   &currentLatestCompletedXid,
+										   latestXid))
+			break;
+	}
+
+	/*
+	 * Mark our top transaction id as commit-in-progress.
+	 */
+	CSNLogSetCommitSeqNo(xid, 0, NULL, COMMITSEQNO_COMMITTING);
+
+	/* Get our CSN and increment */
+	csn = pg_atomic_fetch_add_u64(&ShmemVariableCache->nextCommitSeqNo, 1);
+	Assert(csn >= COMMITSEQNO_FIRST_NORMAL);
+
+	/* Stamp this XID (and sub-XIDs) with the CSN */
+	CSNLogSetCommitSeqNo(xid, nxids, xids, csn);
+
+	LWLockRelease(CommitSeqNoLock);
 }
 
 /*
@@ -289,8 +284,23 @@ TransactionIdAsyncCommitTree(TransactionId xid, int nxids, TransactionId *xids,
 void
 TransactionIdAbortTree(TransactionId xid, int nxids, TransactionId *xids)
 {
-	TransactionIdSetTreeStatus(xid, nxids, xids,
-							   TRANSACTION_STATUS_ABORTED, InvalidXLogRecPtr);
+	TransactionId latestXid;
+	TransactionId currentLatestCompletedXid;
+
+	latestXid = TransactionIdLatest(xid, nxids, xids);
+
+	currentLatestCompletedXid = pg_atomic_read_u32(&ShmemVariableCache->latestCompletedXid);
+	while (TransactionIdFollows(latestXid, currentLatestCompletedXid))
+	{
+		if (pg_atomic_compare_exchange_u32(&ShmemVariableCache->latestCompletedXid,
+										   &currentLatestCompletedXid,
+										   latestXid))
+			break;
+	}
+
+	CSNLogSetCommitSeqNo(xid, nxids, xids, COMMITSEQNO_ABORTED);
+	CLogSetTreeStatus(xid, nxids, xids,
+					  CLOG_XID_STATUS_ABORTED, InvalidXLogRecPtr);
 }
 
 /*
@@ -409,7 +419,7 @@ TransactionIdGetCommitLSN(TransactionId xid)
 	 * checking TransactionLogFetch's cache will usually succeed and avoid an
 	 * extra trip to shared memory.
 	 */
-	if (TransactionIdEquals(xid, cachedFetchXid))
+	if (TransactionIdEquals(xid, cachedLSNFetchXid))
 		return cachedCommitLSN;
 
 	/* Special XIDs are always known committed */
@@ -419,7 +429,10 @@ TransactionIdGetCommitLSN(TransactionId xid)
 	/*
 	 * Get the transaction status.
 	 */
-	(void) TransactionIdGetStatus(xid, &result);
+	(void) CLogGetStatus(xid, &result);
+
+	cachedLSNFetchXid = xid;
+	cachedCommitLSN = result;
 
 	return result;
 }
diff --git a/src/backend/access/transam/twophase.c b/src/backend/access/transam/twophase.c
index ae832917ce..aaea2c5b0a 100644
--- a/src/backend/access/transam/twophase.c
+++ b/src/backend/access/transam/twophase.c
@@ -22,7 +22,7 @@
  *		transaction in prepared state with the same GID.
  *
  *		A global transaction (gxact) also has dummy PGXACT and PGPROC; this is
- *		what keeps the XID considered running by TransactionIdIsInProgress.
+ *		what keeps the XID considered running by the functions in procarray.c.
  *		It is also convenient as a PGPROC to hook the gxact's locks to.
  *
  *		Information to recover prepared transactions in case of crash is
@@ -78,6 +78,7 @@
 
 #include "access/commit_ts.h"
 #include "access/htup_details.h"
+#include "access/mvccvars.h"
 #include "access/subtrans.h"
 #include "access/transam.h"
 #include "access/twophase.h"
@@ -467,6 +468,7 @@ MarkAsPreparingGuts(GlobalTransaction gxact, TransactionId xid, const char *gid,
 	proc->lxid = (LocalTransactionId) xid;
 	pgxact->xid = xid;
 	pgxact->xmin = InvalidTransactionId;
+	pgxact->snapshotcsn = InvalidCommitSeqNo;
 	pgxact->delayChkpt = false;
 	pgxact->vacuumFlags = 0;
 	proc->pid = 0;
@@ -480,9 +482,6 @@ MarkAsPreparingGuts(GlobalTransaction gxact, TransactionId xid, const char *gid,
 	proc->waitProcLock = NULL;
 	for (i = 0; i < NUM_LOCK_PARTITIONS; i++)
 		SHMQueueInit(&(proc->myProcLocks[i]));
-	/* subxid data must be filled later by GXactLoadSubxactData */
-	pgxact->overflowed = false;
-	pgxact->nxids = 0;
 
 	gxact->prepared_at = prepared_at;
 	gxact->xid = xid;
@@ -500,34 +499,6 @@ MarkAsPreparingGuts(GlobalTransaction gxact, TransactionId xid, const char *gid,
 }
 
 /*
- * GXactLoadSubxactData
- *
- * If the transaction being persisted had any subtransactions, this must
- * be called before MarkAsPrepared() to load information into the dummy
- * PGPROC.
- */
-static void
-GXactLoadSubxactData(GlobalTransaction gxact, int nsubxacts,
-					 TransactionId *children)
-{
-	PGPROC	   *proc = &ProcGlobal->allProcs[gxact->pgprocno];
-	PGXACT	   *pgxact = &ProcGlobal->allPgXact[gxact->pgprocno];
-
-	/* We need no extra lock since the GXACT isn't valid yet */
-	if (nsubxacts > PGPROC_MAX_CACHED_SUBXIDS)
-	{
-		pgxact->overflowed = true;
-		nsubxacts = PGPROC_MAX_CACHED_SUBXIDS;
-	}
-	if (nsubxacts > 0)
-	{
-		memcpy(proc->subxids.xids, children,
-			   nsubxacts * sizeof(TransactionId));
-		pgxact->nxids = nsubxacts;
-	}
-}
-
-/*
  * MarkAsPrepared
  *		Mark the GXACT as fully valid, and enter it into the global ProcArray.
  *
@@ -545,7 +516,7 @@ MarkAsPrepared(GlobalTransaction gxact, bool lock_held)
 		LWLockRelease(TwoPhaseStateLock);
 
 	/*
-	 * Put it into the global ProcArray so TransactionIdIsInProgress considers
+	 * Put it into the global ProcArray so GetOldestActiveTransactionId() considers
 	 * the XID as still running.
 	 */
 	ProcArrayAdd(&ProcGlobal->allProcs[gxact->pgprocno]);
@@ -1036,8 +1007,6 @@ StartPrepare(GlobalTransaction gxact)
 	if (hdr.nsubxacts > 0)
 	{
 		save_state_data(children, hdr.nsubxacts * sizeof(TransactionId));
-		/* While we have the child-xact data, stuff it in the gxact too */
-		GXactLoadSubxactData(gxact, hdr.nsubxacts, children);
 	}
 	if (hdr.ncommitrels > 0)
 	{
@@ -1123,7 +1092,7 @@ EndPrepare(GlobalTransaction gxact)
 	 * NB: a side effect of this is to make a dummy ProcArray entry for the
 	 * prepared XID.  This must happen before we clear the XID from MyPgXact,
 	 * else there is a window where the XID is not running according to
-	 * TransactionIdIsInProgress, and onlookers would be entitled to assume
+	 * GetOldestActiveTransactionId, and onlookers would be entitled to assume
 	 * the xact crashed.  Instead we have a window where the same XID appears
 	 * twice in ProcArray, which is OK.
 	 */
@@ -1373,7 +1342,6 @@ FinishPreparedTransaction(const char *gid, bool isCommit)
 	char	   *buf;
 	char	   *bufptr;
 	TwoPhaseFileHeader *hdr;
-	TransactionId latestXid;
 	TransactionId *children;
 	RelFileNode *commitrels;
 	RelFileNode *abortrels;
@@ -1418,14 +1386,11 @@ FinishPreparedTransaction(const char *gid, bool isCommit)
 	invalmsgs = (SharedInvalidationMessage *) bufptr;
 	bufptr += MAXALIGN(hdr->ninvalmsgs * sizeof(SharedInvalidationMessage));
 
-	/* compute latestXid among all children */
-	latestXid = TransactionIdLatest(xid, hdr->nsubxacts, children);
-
 	/*
 	 * The order of operations here is critical: make the XLOG entry for
 	 * commit or abort, then mark the transaction committed or aborted in
 	 * pg_xact, then remove its PGPROC from the global ProcArray (which means
-	 * TransactionIdIsInProgress will stop saying the prepared xact is in
+	 * GetOldestActiveTransactionId() will stop saying the prepared xact is in
 	 * progress), then run the post-commit or post-abort callbacks. The
 	 * callbacks will release the locks the transaction held.
 	 */
@@ -1440,7 +1405,7 @@ FinishPreparedTransaction(const char *gid, bool isCommit)
 									   hdr->nsubxacts, children,
 									   hdr->nabortrels, abortrels);
 
-	ProcArrayRemove(proc, latestXid);
+	ProcArrayRemove(proc);
 
 	/*
 	 * In case we fail while running the callbacks, mark the gxact invalid so
@@ -1926,17 +1891,17 @@ RecoverPreparedTransactions(void)
 		xid = gxact->xid;
 
 		/*
-		 * Reconstruct subtrans state for the transaction --- needed because
-		 * pg_subtrans is not preserved over a restart.  Note that we are
-		 * linking all the subtransactions directly to the top-level XID;
-		 * there may originally have been a more complex hierarchy, but
-		 * there's no need to restore that exactly. It's possible that
-		 * SubTransSetParent has been set before, if the prepared transaction
-		 * generated xid assignment records.
+		 * Reconstruct subtrans state for the transaction --- needed
+		 * because pg_csnlog is not preserved over a restart.  Note that
+		 * we are linking all the subtransactions directly to the
+		 * top-level XID; there may originally have been a more complex
+		 * hierarchy, but there's no need to restore that exactly.
+		 * It's possible that SubTransSetParent has been set before, if
+		 * the prepared transaction generated xid assignment records.
 		 */
 		buf = ProcessTwoPhaseBuffer(xid,
-									gxact->prepare_start_lsn,
-									gxact->ondisk, true, false);
+				gxact->prepare_start_lsn,
+				gxact->ondisk, true, false);
 		if (buf == NULL)
 			continue;
 
@@ -1965,7 +1930,6 @@ RecoverPreparedTransactions(void)
 		/* recovered, so reset the flag for entries generated by redo */
 		gxact->inredo = false;
 
-		GXactLoadSubxactData(gxact, hdr->nsubxacts, subxids);
 		MarkAsPrepared(gxact, true);
 
 		LWLockRelease(TwoPhaseStateLock);
@@ -2026,7 +1990,7 @@ ProcessTwoPhaseBuffer(TransactionId xid,
 		Assert(prepare_start_lsn != InvalidXLogRecPtr);
 
 	/* Already processed? */
-	if (TransactionIdDidCommit(xid) || TransactionIdDidAbort(xid))
+	if (TransactionIdGetStatus(xid) != XID_INPROGRESS)
 	{
 		if (fromdisk)
 		{
@@ -2225,7 +2189,7 @@ RecordTransactionCommitPrepared(TransactionId xid,
 	/* Flush XLOG to disk */
 	XLogFlush(recptr);
 
-	/* Mark the transaction committed in pg_xact */
+	/* Mark the transaction committed in pg_xact and pg_csnlog */
 	TransactionIdCommitTree(xid, nchildren, children);
 
 	/* Checkpoint can proceed now */
@@ -2263,7 +2227,7 @@ RecordTransactionAbortPrepared(TransactionId xid,
 	 * Catch the scenario where we aborted partway through
 	 * RecordTransactionCommitPrepared ...
 	 */
-	if (TransactionIdDidCommit(xid))
+	if (TransactionIdGetStatus(xid) == XID_COMMITTED)
 		elog(PANIC, "cannot abort transaction %u, it was already committed",
 			 xid);
 
